<?php
namespace nulib\db\mysql;

use nulib\db\CapacitorChannel;
use nulib\db\CapacitorStorage;

/**
 * Class MysqlStorage
 */
class MysqlStorage extends CapacitorStorage {
  function __construct($mysql) {
    $this->mysql = Mysql::with($mysql);
  }

  protected Mysql $mysql;

  function db(): Mysql {
    return $this->mysql;
  }

  const PRIMARY_KEY_DEFINITION = [
    "id_" => "integer primary key auto_increment",
  ];

  function _getCreateSql(CapacitorChannel $channel): string {
    $query = new _mysqlQuery($this->_createSql($channel));
    return self::format_sql($channel, $query->getSql());
  }

  function _exists(CapacitorChannel $channel): bool {
    $mysql = $this->mysql;
    $tableName = $mysql->get([
      "select table_name from information_schema.tables",
      "where" => [
        "table_schema" => $mysql->getDbname(),
        "table_name" => $channel->getTableName(),
      ],
    ]);
    return $tableName !== null;
  }

  function close(): void {
    $this->mysql->close();
  }
}
